/*
 * global.h
 *
 *  Created on: 10/02/2010
 *      Author: Saúl Zapotecas
 */

#ifndef GLOBAL_H_
#define GLOBAL_H_

#define GNUPLOT_COMMAND "gnuplot -persist"
#define PATH_FRONTS "REAL_FRONTS/"

#define UNDEFINED_FRONT 0
#define CONVEX_FRONT 1
#define NONCONVEX_FRONT 2

#define INF 1.0e14
#define _INF -1.0e14
#define EPS 1.0e-14
#define EXP  2.71828182845905
#define PI 3.14159265358979

#include "types.h"

extern FILE *popen(const char *command, const char *modes);
extern int pclose(FILE *stream);

extern void (* test_problem)(double*, double*, double*);
extern double (* objective)(double*, double*, double*);

extern mop_parameters mop; /* MOP parmeters */
extern moea_parameters moea; /* MOEA parameters */

#endif /* GLOBAL_H_ */
