/*
 * initialize.c
 *
 *  Created on: 16/02/2010
 *      Author: Saúl Zapotecas
 */

#include <stdio.h>
#include <stdlib.h>

#include "global.h"
#include "rand.h"
#include "moea_tools.h"

void initialize_pop_LH(population *pop)
{
	int i, j;
	int *vector;
	double cel, tmp;
	vector = (int*) malloc(sizeof(int) * pop->size);
	for (i = 0; i < pop->size; i++)
	{
		vector[i] = i + 1;
	}
	for (j = 0; j < mop.nreal; j++)
	{
		shuffle(vector, pop->size);
		cel = (mop.up_bound[j] - mop.low_bound[j]) / ((double) pop->size);
		for (i = 0; i < pop->size; i++)
		{
			tmp = mop.low_bound[j] + (cel * (double) vector[i]) - (cel / 2.0);
			pop->ind[i].pb_xreal[j] = pop->ind[i].xreal[j] = tmp;
			pop->ind[i].vel[j] = 0.0;
			if (j < mop.nobj)
			{
				pop->ind[i].pb_obj[j] = 0.0;
			}
			if (tmp < mop.low_bound[j] || tmp > mop.up_bound[j])
			{
				printf("LOW: %f\tUP:%f\n", mop.low_bound[j], mop.up_bound[j]);
				printf("CEL: %f\tS: %f\n", cel, (double) vector[i]);
				printf("xreal[%d]: %f\n", j, tmp);
				printf("Esto no debiera de pasar\n");
				exit(0);
			}
			pop->ind[i].age = 0;
			pop->ind[i].problem_id = i;
		}

	}
	free(vector);
	return;
}

/* *
 * Generate uniform weights (for 2 and 3 objectives)
 * */
void initialize_uniform_weights(weight *W, int H)
{
	int i, j, index = 0;

	if (W->size != moea.pop_size)
	{
		printf("ERROR: Number of problems different from population size\n");
		exit(0);
	}
	if (mop.nobj == 2)
	{
		for (i = 0; i <= H; i++)
		{
			W->weight[index].w[0] = (double) (1.0 * i) / H;
			W->weight[index].w[1] = (double) (1.0 * (H - i)) / H;
			index++;
		}
	}
	else
	{
		for (i = 0; i <= H; i++)
		{
			for (j = 0; j <= H; j++)
			{
				if (i + j <= H)
				{
					W->weight[index].w[0] = (double) (1.0 * i) / H;
					W->weight[index].w[1] = (double) (1.0 * j) / H;
					W->weight[index].w[2] = (double) (1.0 * (H - i - j)) / H;
					index++;
				}
			}
		}
	}
	/* printing weights
	 for (i = 0; i < moea.pop_size; i++)
	 {
	 for (j = 0; j < mop.nobj; j++)
	 {
	 printf("%.6f", W->weight[i].w[j]);
	 }
	 printf("\n");
	 }
	 */
	if (index != moea.pop_size)
	{
		printf(
				"ERROR: Number of weights different from population size (%d!=%d)\n",
				index, moea.pop_size);
		exit(0);
	}
	return;
}

void initialize_ind(individual *ind)
{
	int j;
	for (j = 0; j < mop.nreal; j++)
	{
		ind->xreal[j] = rndreal(mop.low_bound[j], mop.up_bound[j]);
	}
	return;
}

void initialize_pop(population *pop)
{
	int i;
	for (i = 0; i < pop->size; i++)
	{
		initialize_ind(&(pop->ind[i]));
		pop->ind[i].age = 0;
	}
	return;
}
