/*
 * io_data.c
 *
 *  Created on: 10/02/2010
 *      Author: Saúl Zapotecas
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "global.h"
#include "allocate.h"

void reading_input_data()
{
	int j;
	printf("\n\n\n[[[[[[[[[[ Reading input data ]]]]]]]]]]\n");
	printf("Enter MOP name (see readme): ");
	scanf("%s", mop.str_mop_name);
	printf("\nEnter population size: ");
	scanf("%d", &moea.pop_size);
	printf("\nEnter number of generations: ");
	scanf("%d", &moea.max_gen);
	printf("\nEnter number of objectives: ");
	scanf("%d", &mop.nobj);
	printf("\nEnter number of constrains: ");
	scanf("%d", &mop.nconst);
	printf("\nEnter number of variables: ");
	scanf("%d", &mop.nreal);
	mop.low_bound = (double*) malloc(sizeof(double) * mop.nreal);
	mop.up_bound = (double*) malloc(sizeof(double) * mop.nreal);
	for (j = 0; j < mop.nreal; j++)
	{
		printf("\n\tlow bound for x[%d]: ", j + 1);
		scanf("%lf", &mop.low_bound[j]);
		printf("\n\t up bound for x[%d]: ", j + 1);
		scanf("%lf", &mop.up_bound[j]);
	}
	printf("\nEnter probability of crossover: ");
	scanf("%lf", &moea.Pc);
	printf("\nEnter probability of mutation: ");
	scanf("%lf", &moea.Pm);
	return;
}

void printing_input_data()
{
	int j;
	printf("\n\n\n********** Printing read data **********\n");
	printf("MOP name: %s\n", mop.str_mop_name);
	printf("Population size: %d\n", moea.pop_size);
	printf("Number of generations: %d\n", moea.max_gen);
	printf("Number of objectives: %d\n", mop.nobj);
	printf("Number of constrains: %d\n", mop.nconst);
	printf("Number of variables: %d\n", mop.nreal);
	for (j = 0; j < mop.nreal; j++)
	{
		printf("\tlow bound for x[%d]: %f\n", j + 1, mop.low_bound[j]);
		printf("\t up bound for x[%d]: %f\n", j + 1, mop.up_bound[j]);
	}
	printf("Probability of crossover: %f\n", moea.Pc);
	printf("Probability of mutation: %f\n", moea.Pm);
	return;
}

void printf_ind(individual *ind)
{
	int j;
	j = 0;

	/* printf("X:\n"); */
	for (j = 0; j < mop.nobj; j++)
	{
		printf("%f ", ind->obj[j]);
	}
	printf("\n");
	/*
	 for (j = 0; j < mop.nobj; j++)
	 printf("%f ", ind->obj[j]);
	 printf("\n");
	 */
	/*printf("label: %d\n", ind->label1);*/
	return;
}

void printf_pop(population *pop)
{
	int i;
	for (i = 0; i < pop->size; i++)
	{
		printf("%d\t", i);
		printf_ind(&(pop->ind[i]));
	}
	return;
}

