/*
 * problemdef.c
 *
 *  Created on: 24/09/2010
 *      Author: Saúl Zapotecas
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "global.h"

#include "MOPs/zdt.h"
#include "MOPs/dtlz.h"
#include "MOPs/classicMOPs.h"

void define_MOP_info(char *path, char *problem)
{
	static int flag = 0;
	if (!flag)
	{
		/* The file name of real Pareto front */
		sprintf(mop.str_real_front_data, "%s%s.FRONT", path, problem);

		/* The file name of real Pareto front */
		sprintf(mop.str_real_front_plot, "%s%s.PLOT", path, problem);

		printf("%s\n", mop.str_real_front_data);
		/*read_solutions(mop.str_real_front_data, mop.real_pareto_front);*/
		flag = 1;
	}
	return;
}

int setting_CLASSIC_MOP(char *problem)
{
	/* Classic MOPs */
	if (strcmp(problem, "FONSECA") == 0)
	{
		test_problem = &Fonseca;
		return 1;
	}
	if (strcmp(problem, "KURSAWE") == 0)
	{
		test_problem = &Kursawe;
		return 1;
	}
	if (strcmp(problem, "POLI") == 0)
	{
		test_problem = &Poli;
		return 1;
	}
	if (strcmp(problem, "SCHAFFER") == 0)
	{
		test_problem = &Schaffer;
		return 1;
	}
	if (strcmp(problem, "VIENNET1") == 0)
	{
		test_problem = &Viennet1;
		return 1;
	}
	if (strcmp(problem, "VIENNET2") == 0)
	{
		test_problem = &Viennet2;
		return 1;
	}
	if (strcmp(problem, "VIENNET3") == 0)
	{
		test_problem = &Viennet3;
		return 1;
	}
	return 0;
}

int setting_ZDT_mop(char *problem)
{
	/* ZDT Benchmark */
	if (strcmp(problem, "ZDT1") == 0)
	{
		test_problem = &ZDT1;
		return 1;
	}
	if (strcmp(problem, "ZDT2") == 0)
	{
		test_problem = &ZDT2;
		return 1;
	}
	if (strcmp(problem, "ZDT3") == 0)
	{
		test_problem = &ZDT3;
		return 1;
	}
	if (strcmp(problem, "ZDT4") == 0)
	{
		test_problem = &ZDT4;
		return 1;
	}
	if (strcmp(problem, "ZDT6") == 0)
	{
		test_problem = &ZDT6;
		return 1;
	}
	return 0;
}

int setting_DTLZ_mop(char *problem)
{
	/* DTLZ Benchmark */
	if (strcmp(problem, "DTLZ1") == 0)
	{
		test_problem = &DTLZ1;
		return 1;
	}
	if (strcmp(problem, "DTLZ2") == 0)
	{
		test_problem = &DTLZ2;
		return 1;
	}
	if (strcmp(problem, "DTLZ3") == 0)
	{
		test_problem = &DTLZ3;
		return 1;
	}
	if (strcmp(problem, "DTLZ4") == 0)
	{
		test_problem = &DTLZ4;
		return 1;
	}
	if (strcmp(problem, "DTLZ5") == 0)
	{
		test_problem = &DTLZ5;
		return 1;
	}
	if (strcmp(problem, "DTLZ6") == 0)
	{
		test_problem = &DTLZ6;
		return 1;
	}
	if (strcmp(problem, "DTLZ7") == 0)
	{
		test_problem = &DTLZ7;
		return 1;
	}
	return 0;
}

void setting_mop(char *problem)
{

	if (setting_CLASSIC_MOP(problem))
	{
		define_MOP_info(PATH_FRONTS, problem);
		return;
	}
	if (setting_ZDT_mop(problem))
	{
		define_MOP_info(PATH_FRONTS, problem);
		return;
	}
	if (setting_DTLZ_mop(problem))
	{
		define_MOP_info(PATH_FRONTS, problem);
		return;
	}

	printf("ERROR: The MOP \"%s\" is not available for this MOEA\n", problem);
	exit(0);
	return;
}

