/*
 * report.c
 *
 *  Created on: 20/09/2009
 *      Author: Saúl Zapotecas
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "global.h"

void report_pop(population *pop, int psize)
{
	int i, j;
	FILE *file_pop, *file_obj;

	file_pop = fopen("pop.dat", "w+");
	file_obj = fopen("pop.plot", "w+");

	fprintf(file_obj, "# f[1], f[2], ..., f[m],(m=%d)\n", mop.nobj);
	fprintf(file_pop,
			"# x[1], x[2], ..., x[n], (n=%d)\t f[1], f[2], ..., f[m],(m=%d)\n",
			mop.nreal, mop.nobj);
	for (i = 0; i < psize; i++)
	{
		for (j = 0; j < mop.nreal; j++)
		{
			fprintf(file_pop, "%f ", pop->ind[i].xreal[j]);
		}
		for (j = 0; j < mop.nobj; j++)
		{
			fprintf(file_pop, "%f ", pop->ind[i].obj[j]);
			fprintf(file_obj, "%f ", pop->ind[i].obj[j]);
		}
		fprintf(file_pop, "\n");
		fprintf(file_obj, "\n");
	}
	fclose(file_pop);
	fclose(file_obj);
	return;
}

void display_pop(population *pop, FILE *gp, int ii)
{
	FILE *file;
	int i, j;
	char file_plot[255] = "plot.out";
	file = fopen(file_plot, "w+");

	for (i = 0; i < pop->size; i++)
	{
		for (j = 0; j < mop.nobj; j++)
		{
			fprintf(file, "%f ", pop->ind[i].obj[j]);
		}
		fprintf(file, "\n");
		fflush(file);
	}
	if (mop.nobj == 2)
	{
		fprintf(gp, "set title '[%s] Generation #%d (%d eval)'\n",
				mop.str_mop_name, ii, moea.evaluations);
		fprintf(gp, "unset key\n");
		fprintf(gp, "set xlabel \"f1\"\n");
		fprintf(gp, "set ylabel \"f2\"\n");
		if (strcmp(mop.str_real_front_plot, "") == 0)
		{
			/*fprintf(gp, "plot '%s' w l lt 1 lw 1, ", mop.real_char_front_plot);*/
			fprintf(gp, "plot '%s' w p pt 6 ps 1\n", file_plot);
		}
		else
		{
			fprintf(gp, "plot '%s' w l lt 1 lw 1, ", mop.str_real_front_plot);
			fprintf(gp, "'%s' w p pt 1 linecolor 5, ", file_plot);
			fprintf(gp, "'%s' w p pt 19 linecolor 3\n", file_plot);
		}
	}
	else if (mop.nobj == 3)
	{
		fprintf(gp, "unset key\n");
		fprintf(gp, "set title '[%s] Generation #%d (%d eval)'\n",
				mop.str_mop_name, ii, moea.evaluations);
		fprintf(gp,
				"set palette defined (0 \"black\", 1 \"red\", 2 \"yellow\")\n");
		fprintf(gp, "set view 50, 65, 1, 1\n");
		/*fprintf(gp, "set view 40, 140, 1, 1\n");*/
		fprintf(gp, "set xlabel \"f1\"\n");
		fprintf(gp, "set ylabel \"f2\"\n");
		fprintf(gp, "set zlabel \"f3\"\n");
		fprintf(gp, "set ticslevel 0\n");
		fprintf(gp, "set border 1+2+4+8+16+32+64+128+256+512+1024+2048\n");

		fprintf(
				gp,
				"set pm3d interpolate 1,1 flush begin noftriangles hidden3d 100 corners2color mean\n");
		fprintf(gp, "splot '%s' w pm3d, ", mop.str_real_front_plot);
		/*fprintf(gp, "splot '%s' w pm3d, ", mop.real_char_front_plot);*/
		/*fprintf(gp, "splot '%s' w p pt 2 ps 1,", mop.real_char_front_plot);*/

		fprintf(gp, "'%s' w p pt 1 linecolor 5, ", file_plot);
		fprintf(gp, "'%s' w p pt 19 linecolor 3\n", file_plot);
	}
	else
	{
		printf("ERROR: It's no possible graphic 3 functions\n");
	}
	fflush(gp);
	fclose(file);
	return;
}

void report_run(FILE *file, population *pop, int gen)
{
	int i, j;
	fprintf(file, "# gen = %d\n", gen);
	for (i = 0; i < pop->size; i++)
	{
		for (j = 0; j < mop.nobj; j++)
		{
			fprintf(file, "%f ", pop->ind[i].obj[j]);
		}
		fprintf(file, "\n");
	}
	fprintf(file, "# end gen = %d\n", gen);
	return;
}
