/*
 * scalarization.c
 *
 *  Created on: 18/08/2010
 *      Author: Saúl Zapotecas
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"

double WEI(double *F, double *lambda, double *z)
{
	int i;
	double sum = 0.0;
	for (i = 0; i < mop.nobj; i++)
	{
		sum += lambda[i] * F[i];
	}
	return sum;
}

double TCH(double *F, double *lambda, double *z)
{
	int i;
	double tmp, res = -1.0e+10;
	for (i = 0; i < mop.nobj; i++)
	{
		tmp = lambda[i] * fabs(F[i] - z[i]);
		res = (res < tmp) ? tmp : res;
	}
	return res;
}

double NBI(double *F, double *lambda, double *z)
{
	int i;
	double d1, d2, nl;
	double theta = 5.0;

	d1 = d2 = nl = 0.0;
	for (i = 0; i < mop.nobj; i++)
	{
		d1 += (F[i] - z[i]) * lambda[i];
		nl += pow(lambda[i], 2.0);
	}
	nl = sqrt(nl);
	d1 = fabs(d1) / nl;
	for (i = 0; i < mop.nobj; i++)
	{
		d2 += pow((F[i] - z[i]) - d1 * (lambda[i] / nl), 2.0);
	}
	d2 = sqrt(d2);
	return (d1 + theta * d2);
}
