/*
 * update.c
 *
 *  Created on: 01/10/2010
 *      Author: Saúl Zapotecas
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"
#include "allocate.h"
#include "moea_tools.h"

void assignment_problem_to_solution(weight *W, population *pop)
{
	int i, j;
	double scalarization;

	printf("%d %d\n", pop->size, W->size);
	for (i = 0; i < pop->size; i++)
	{
		pop->ind[i].scalarization = INF;
		pop->ind[i].problem_id = 0;
		for (j = 0; j < W->size; j++)
		{
			scalarization = objective(pop->ind[i].obj, W->weight[j].w, moea.z);
			if (scalarization <= pop->ind[i].scalarization)
			{
				pop->ind[i].scalarization = scalarization;
				pop->ind[i].problem_id = j;
			}
		}
	}
	printf("\tassignment..... OK\n");
	return;
}

void update_pop(weight *W, population *mixed_pop, population *parent_pop)
{
	int i, j, index;
	int *v;
	double min, scalarization;

	if (parent_pop->size != W->size)
	{
		printf("ERROR: Update, |new_pop|<>|W|");
		exit(0);
	}
	v = (int*) malloc(sizeof(int) * mixed_pop->size);
	for (i = 0; i < mixed_pop->size; i++)
		v[i] = -1;
	for (j = 0; j < W->size; j++)
	{
		min = INF;
		index = 0;
		for (i = 0; i < mixed_pop->size; i++)
		{
			scalarization = objective(mixed_pop->ind[i].obj, W->weight[j].w,
					moea.z);
			if (scalarization < min && v[i] < 0)
			{
				min = scalarization;
				index = i;
			}
		}
		v[index] = 1;
		copy_ind(&(mixed_pop->ind[index]), &(parent_pop->ind[j]));
		parent_pop->ind[j].problem_id = j;
		parent_pop->ind[j].scalarization = min;

	}
	printf("\tupdating pop... OK\n");
	free(v);
	return;
}
